unit exemple;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBTables, ComCtrls, Menus, ExtCtrls, StdCtrls, AboutDlg;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    dbPersonnel: TDatabase;
    tbEmp: TTable;{ Emp}
    scTables: TDataSource;{DataSource    dbgdTable}
    dbgdTable: TDBGrid;{         SQL}
    mnMnu: TMainMenu;
    tbDept: TTable;{ Dept}
    t1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Emp1: TMenuItem;
    Dept1: TMenuItem;
    qrExample: TQuery; {,      }
    dsQuery: TDataSource;{DataSource      dbgdTable}
    pnList: TPanel;{    }
    dbgrdQueryList: TDBGrid; {     }
    qsQueryList: TQuery; {      }
    qrResult: TQuery;{,    }
    edtObj: TEdit; {       }
    mmSqlstr: TMemo; {     SQL    }
    qrObj: TQuery; {,      }
    dsQeuryList: TDataSource; {DataSource    }
    Queries1: TMenuItem;
    tbQueries: TTable; {  }
 
    procedure Emp1Click(Sender: TObject);
    procedure Dept1Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure dbgrdQueryListDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mmSqlstrEnter(Sender: TObject);
    procedure mmSqlstrExit(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure Queries1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
  private
    { Private declarations }
  public

    { Public declarations }
  end;

var
  Form1: TForm1;
  chooseNo : integer;
  sqlchanged : boolean; {   SQL?}
implementation

{$R *.DFM}





procedure TForm1.Emp1Click(Sender: TObject);
{    Emp}
begin
{  edtObj  mmSqlstr}
 edtObj.Text :=''; 
   mmSqlstr.Lines.Clear;

  dbgdTable.DataSource := scTables;{   DataSource   }
  ScTables.DataSet :=  tbEmp; {  DataSource   }
end;

procedure TForm1.Dept1Click(Sender: TObject);
{    Dept}
begin
edtObj.Text :='';
  dbgdTable.DataSource := scTables;
  ScTables.DataSet :=  tbDept;
  mmSqlstr.Lines.Clear;
end;



procedure TForm1.N3Click(Sender: TObject);
{   }
begin
 {   }
  pnList.Visible := true;
  pnList.Enabled := true;
  dbgrdQueryList.Visible := true;
  dbgrdQueryList.Enabled :=true;
  dbgdTable.DataSource := dsQuery;{  DataSource   }

end;


procedure TForm1.dbgrdQueryListDblClick(Sender: TObject);
{    }
 var
  i, j: Integer;
  s: string;
begin
  {   }
  chooseNo:=0;
    with dbgrdQueryList.DataSource.DataSet do

      begin
          chooseNo:=Fields[0].asInteger;

      end;
  
 {   }
  pnList.Visible := false;
  pnList.Enabled := false;
  dbgrdQueryList.Visible := false;
  dbgrdQueryList.Enabled :=false;


  if chooseNo > 0 then {   ?}
  begin
   SqlChanged := false;
   { SQL }
   qrResult.Close;
     qrExample.close ;

     qrresult.ParamByName('chNom').value:= chooseNo; {       }
     qrresult.Prepare;
     qrresult.open;
      qrObj.Close;
      edtObj.Text :='';
     qrObj.ParamByName('chNom').value:= chooseNo;
     qrObj.Prepare;
     qrObj.open;

{ 2-  edtObj  mmSqlstr}
     edtObj.Text := qrObj.Fields[0].asString;
     qrExample.SQL.clear;
     mmSqlstr.Lines.Clear;
     mmSqlstr.Lines.Add(qrresult.Fields[0].asString);
{  qrExample SQL      }
     qrExample.SQL.Add(qrresult.Fields[0].asString);
     qrExample.open ;


  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
{,      -      2- }
begin
   SqlChanged := false;
with dbPersonnel do begin

        Params.Values['USER NAME'] := 'SYSDBA';
        Params.Values['PASSWORD'] := 'masterkey';
        LoginPrompt := False;{       UserName  Password}
        Connected := True;
	end;
        dbPersonnel.Connected := true; {  }

        {       }
	  tbEmp.Open; 
        tbDept.Open;
        tbQueries.Open;
         qsQueryList.Open;
end;


procedure TForm1.mmSqlstrEnter(Sender: TObject);
{     SQL }
begin
  SqlChanged := true;
end;

procedure TForm1.mmSqlstrExit(Sender: TObject);
{     SQL }
 var
    newSQL : String;
    i : integer;
begin
  if Sqlchanged and mmSqlstr.Modified then {   SQL ?}
  begin
  {     }
  newSQL := '';
  for i :=0 to mmSqlstr.Lines.Count-1 do
    newSql := newSQL + mmSqlstr.Lines[i];
   
 {  qrExample SQL }
    qrExample.SQL.clear;
     qrExample.SQL.Add(newSql);
   try
     { SQL }
     qrExample.open ;
     except
       on Exception do
       begin
         showmessage(' SQL '); {    }
       end;
   end;
  end;


end;

procedure TForm1.N4Click(Sender: TObject);

begin
   close;
end;


procedure TForm1.Queries1Click(Sender: TObject);
begin
     edtObj.Text :='';
   mmSqlstr.Lines.Clear;
  dbgdTable.DataSource := scTables;
  ScTables.DataSet :=  tbQueries;

end;

procedure TForm1.N1Click(Sender: TObject);
{  ""}
  var
  About : TOKBottomDlg1;
begin
   About := TOKBottomDlg1.Create(self);
   About.ShowModal;
   About.free;
end;

end.
